diff --git a/modules/NUCLEO-F103RB/board.c b/modules/NUCLEO-F103RB/board.c
index 7968e7f..44c0770 100644
--- a/modules/NUCLEO-F103RB/board.c
+++ b/modules/NUCLEO-F103RB/board.c
@@ -18,6 +18,18 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 #include "hal.h"
 
+/*===========================================================================*/
+/* Driver local definitions.                                                 */
+/*===========================================================================*/
+
+/*===========================================================================*/
+/* Driver exported variables.                                                */
+/*===========================================================================*/
+
+/*===========================================================================*/
+/* Driver local variables and types.                                         */
+/*===========================================================================*/
+
 /**
  * @brief   PAL setup.
  * @details Digital I/O ports static configuration as defined in @p board.h.
@@ -34,6 +46,18 @@ const PALConfig pal_default_config =
 };
 #endif
 
+/*===========================================================================*/
+/* Driver local functions.                                                   */
+/*===========================================================================*/
+
+/*===========================================================================*/
+/* Driver interrupt handlers.                                                */
+/*===========================================================================*/
+
+/*===========================================================================*/
+/* Driver exported functions.                                                */
+/*===========================================================================*/
+
 /*
  * Early initialization code.
  * This initialization must be performed just after stack setup and before
diff --git a/modules/NUCLEO-F103RB/board.h b/modules/NUCLEO-F103RB/board.h
index 9b4c995..371783c 100644
--- a/modules/NUCLEO-F103RB/board.h
+++ b/modules/NUCLEO-F103RB/board.h
@@ -19,6 +19,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #ifndef BOARD_H
 #define BOARD_H
 
+/*===========================================================================*/
+/* Driver constants.                                                         */
+/*===========================================================================*/
+
 /*
  * Setup for the ST NUCLEO64-F103RB board.
  */
@@ -51,6 +55,11 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #define STM32F103xB
 
 /*
+ * Identifiers for optional peripherals.
+ */
+#define BOARD_DW1000_CONNECTED      false
+
+/*
  * IO pins assignments.
  */
 #define GPIOA_ARD_A0                0U
@@ -211,6 +220,21 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #define LINE_OSC_IN                 PAL_LINE(GPIOD, GPIOH_OSC_IN)
 #define LINE_OSC_OUT                PAL_LINE(GPIOD, GPIOH_OSC_OUT)
 
+/*===========================================================================*/
+/* Driver pre-compile time settings.                                         */
+/*===========================================================================*/
+
+/*===========================================================================*/
+/* Derived constants and error checks.                                       */
+/*===========================================================================*/
+
+/*===========================================================================*/
+/* Driver data structures and types.                                         */
+/*===========================================================================*/
+
+/*===========================================================================*/
+/* Driver macros.                                                            */
+/*===========================================================================*/
 
 /*
  * I/O ports initial setup, this configuration is established soon after reset
@@ -295,6 +319,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #define usb_lld_disconnect_bus(usbp)
 
+/*===========================================================================*/
+/* External declarations.                                                    */
+/*===========================================================================*/
+
 #if !defined(_FROM_ASM_)
 #ifdef __cplusplus
 extern "C" {
diff --git a/modules/NUCLEO-F103RB/halconf.h b/modules/NUCLEO-F103RB/halconf.h
index d2636a0..aa28d78 100644
--- a/modules/NUCLEO-F103RB/halconf.h
+++ b/modules/NUCLEO-F103RB/halconf.h
@@ -33,7 +33,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #define _CHIBIOS_HAL_CONF_
 #define _CHIBIOS_HAL_CONF_VER_7_0_
 
-#include "mcuconf.h"
+#include <mcuconf.h>
 
 /**
  * @brief   Enables the PAL subsystem.
diff --git a/modules/NUCLEO-F103RB/module.c b/modules/NUCLEO-F103RB/module.c
index 11fcafd..b147329 100644
--- a/modules/NUCLEO-F103RB/module.c
+++ b/modules/NUCLEO-F103RB/module.c
@@ -24,7 +24,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @{
  */
 
-#include "module.h"
+#include <amiroos.h>
 
 /*===========================================================================*/
 /**
@@ -49,7 +49,7 @@ SerialConfig moduleHalProgIfConfig = {
   /* CR1      */ 0,
 };
 
-#if defined(AMIROLLD_CFG_DW1000)
+#if (BOARD_DW1000_CONNECTED == true)
 
 /*! SPI (high and low speed) configuration for DW1000 */
 SPIConfig moduleHalSpiUwbHsConfig = {
@@ -70,7 +70,7 @@ SPIConfig moduleHalSpiUwbLsConfig = {
   /* CR2                         */ 0,
 };
 
-#endif /* defined(AMIROLLD_CFG_DW1000) */
+#endif /* (BOARD_DW1000_CONNECTED == true) */
 
 /** @} */
 
@@ -85,7 +85,7 @@ SPIConfig moduleHalSpiUwbLsConfig = {
  * @brief   LED output signal GPIO.
  */
 static apalGpio_t _gpioLed = {
-  /* line */ PAL_LINE(GPIOA, GPIOA_LED_GREEN),
+  /* line */ LINE_LED_GREEN,
 };
 ROMCONST apalControlGpio_t moduleGpioLed = {
   /* GPIO */ &_gpioLed,
@@ -96,7 +96,7 @@ ROMCONST apalControlGpio_t moduleGpioLed = {
   },
 };
 
-#if defined(AMIROLLD_CFG_DW1000)
+#if (BOARD_DW1000_CONNECTED == true)
 
 /**
  * @brief   DW1000 reset output signal GPIO.
@@ -145,13 +145,13 @@ ROMCONST apalControlGpio_t moduleGpioSpiChipSelect = {
   },
 };
 
-#endif /* defined(AMIROLLD_CFG_DW1000) */
+#endif /* (BOARD_DW1000_CONNECTED == true) */
 
 /**
  * @brief   User button input signal GPIO.
  */
 static apalGpio_t _gpioUserButton = {
-  /* line */ PAL_LINE(GPIOC, GPIOC_BUTTON),
+  /* line */ LINE_BUTTON,
 };
 ROMCONST apalControlGpio_t moduleGpioUserButton = {
   /* GPIO */ &_gpioUserButton,
@@ -184,6 +184,7 @@ ROMCONST char* moduleShellPrompt = "NUCLEO-F103RB";
  */
 /*===========================================================================*/
 
+/** @} */
 
 /*===========================================================================*/
 /**
@@ -192,7 +193,7 @@ ROMCONST char* moduleShellPrompt = "NUCLEO-F103RB";
  */
 /*===========================================================================*/
 
-#if defined(AMIROLLD_CFG_DW1000)
+#if (BOARD_DW1000_CONNECTED == true)
 
 /*! @brief TODO: Manual implementation of SPI configuration. Somehow, it is necessary in NUCLEO-F103RB  */
 void dw1000_spi_init(void){
@@ -203,7 +204,7 @@ void dw1000_spi_init(void){
   apalGpioWrite(moduleGpioSpiChipSelect.gpio, APAL_GPIO_LOW);
 }
 
-#endif /* defined(AMIROLLD_CFG_DW1000) */
+#endif /* (BOARD_DW1000_CONNECTED == true) */
 /** @} */
 
 /*===========================================================================*/
@@ -213,7 +214,15 @@ void dw1000_spi_init(void){
  */
 /*===========================================================================*/
 
-#if defined(AMIROLLD_CFG_DW1000)
+LEDDriver moduleLldLed = {
+  /* LED enable Gpio */ &moduleGpioLed,
+};
+
+ButtonDriver moduleLldUserButton = {
+  /* Button Gpio  */ &moduleGpioUserButton,
+};
+
+#if (BOARD_DW1000_CONNECTED == true)
 
 DW1000Driver moduleLldDw1000 = {
   /* SPI driver         */ &MODULE_HAL_SPI_UWB,
@@ -221,18 +230,39 @@ DW1000Driver moduleLldDw1000 = {
   /* RESET DW1000       */ &moduleGpioDw1000Reset,
 };
 
-#endif /* defined(AMIROLLD_CFG_DW1000) */
+#endif /* (BOARD_DW1000_CONNECTED == true) */
+
 /** @} */
 
 /*===========================================================================*/
 /**
- * @name Unit tests (UT)
+ * @name Tests
  * @{
  */
 /*===========================================================================*/
 #if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
 
-#if defined(AMIROLLD_CFG_DW1000)
+/*
+ * LED
+ */
+#include <module_test_LED.h>
+static int _testLedShellCmdCb(BaseSequentialStream* stream, int argc, char* argv[])
+{
+  return moduleTestLedShellCb(stream, argc, argv, NULL);
+}
+AOS_SHELL_COMMAND(moduleTestLedShellCmd, "test:LED", _testLedShellCmdCb);
+
+/*
+ * User button
+ */
+#include <module_test_button.h>
+static int _testButtonShellCmdCb(BaseSequentialStream* stream, int argc, char* argv[])
+{
+  return moduleTestButtonShellCb(stream, argc, argv, NULL);
+}
+AOS_SHELL_COMMAND(moduleTestButtonShellCmd, "test:button", _testButtonShellCmdCb);
+
+#if (BOARD_DW1000_CONNECTED == true) || defined(__DOXYGEN__)
 
 /*
  * UwB Driver (DW1000)
@@ -255,7 +285,39 @@ aos_unittest_t moduleUtAlldDw1000 = {
   },
   /* data           */ &moduleLldDw1000,
 };
-#endif /* defined(AMIROLLD_CFG_DW1000) */
+#endif /* (BOARD_DW1000_CONNECTED == true) */
+
+/*
+ * entire module
+ */
+static int _testAllShellCmdCb(BaseSequentialStream* stream, int argc, char* argv[])
+{
+  (void)argc;
+  (void)argv;
+
+  int status = AOS_OK;
+  char* targv[AMIROOS_CFG_SHELL_MAXARGS] = {NULL};
+  aos_testresult_t result_test = {0, 0};
+  aos_testresult_t result_total = {0, 0};
+
+  /* LED */
+  status |= moduleTestLedShellCb(stream, 0, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+
+  /* User button */
+  status |= moduleTestButtonShellCb(stream, 0, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+
+  /* DW1000 */
+  //TODO
+
+  // print total result
+  chprintf(stream, "\n");
+  aosTestResultPrintSummary(stream, &result_total, "entire module");
+
+  return status;
+}
+AOS_SHELL_COMMAND(moduleTestAllShellCmd, "test:all", _testAllShellCmdCb);
 
 #endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
 
diff --git a/modules/NUCLEO-F103RB/module.h b/modules/NUCLEO-F103RB/module.h
index 344337c..4ede7fd 100644
--- a/modules/NUCLEO-F103RB/module.h
+++ b/modules/NUCLEO-F103RB/module.h
@@ -36,7 +36,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 /*===========================================================================*/
 
-#if defined(AMIROLLD_CFG_DW1000)
+#if (BOARD_DW1000_CONNECTED == true)
 
 #if defined(__cplusplus)
 extern "C" {
@@ -48,7 +48,7 @@ void dw1000_spi_init(void);
 }
 #endif /* defined(__cplusplus) */
 
-#endif /* defined(AMIROLLD_CFG_DW1000) */
+#endif /* (BOARD_DW1000_CONNECTED == true) */
 
 
 /** @} */
@@ -75,15 +75,13 @@ extern SerialConfig moduleHalProgIfConfig;
  */
 #define MODULE_HAL_RTC                          RTCD1
 
-
-#if defined(AMIROLLD_CFG_DW1000)
+#if (BOARD_DW1000_CONNECTED == true)
 
 /**
  * @brief   SPI interface driver for the motion sensors (gyroscope and accelerometer).
  */
 #define MODULE_HAL_SPI_UWB                      SPID2
 
-
 /**
  * @brief   Configuration for the SPI interface driver to communicate with the LED driver.
  */
@@ -94,11 +92,10 @@ extern SPIConfig moduleHalSpiUwbHsConfig;
  */
 extern SPIConfig moduleHalSpiUwbLsConfig;
 
-#endif /* defined(AMIROLLD_CFG_DW1000) */
+#endif /* (BOARD_DW1000_CONNECTED == true) */
 
 /** @} */
 
-
 /*===========================================================================*/
 /**
  * @name GPIO definitions
@@ -111,7 +108,8 @@ extern SPIConfig moduleHalSpiUwbLsConfig;
  */
 extern ROMCONST apalControlGpio_t moduleGpioLed;
 
-#if defined(AMIROLLD_CFG_DW1000)
+#if (BOARD_DW1000_CONNECTED == true)
+
 /**
  * @brief   DW1000 reset output signal
  * @note    the reset pin should be drived as low by MCU to activate.
@@ -130,7 +128,7 @@ extern ROMCONST apalControlGpio_t moduleGpioDw1000Irqn;
  */
 extern ROMCONST apalControlGpio_t moduleGpioSpiChipSelect ;
 
-#endif /* defined(AMIROLLD_CFG_DW1000) */
+#endif /* (BOARD_DW1000_CONNECTED == true) */
 
 /**
  * @brief   User button input signal.
@@ -146,17 +144,20 @@ extern ROMCONST apalControlGpio_t moduleGpioUserButton;
  */
 /*===========================================================================*/
 
+#if (BOARD_DW1000_CONNECTED == true)
+
 /**
  * @brief   Event flag to be call dwt_isr() interrupt.
  */
 #define MODULE_OS_IOEVENTFLAGS_DW1000_IRQn      AOS_IOEVENT_FLAG(PAL_PAD(LINE_ARD_D6))
 
+#endif /* (BOARD_DW1000_CONNECTED == true) */
+
 /**
  * @brief   Event flag to be set on a USER_BUTTON interrupt.
  */
 #define MODULE_OS_IOEVENTFLAGS_USERBUTTON       AOS_IOEVENT_FLAG(PAL_PAD(LINE_BUTTON))
 
-
 #if (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
 /**
  * @brief   Shell prompt text.
@@ -174,72 +175,75 @@ extern ROMCONST char* moduleShellPrompt;
   palEnableLineEvent(moduleGpioUserButton.gpio->line, APAL2CH_EDGE(moduleGpioUserButton.meta.edge));                \
   MODULE_INIT_INTERRUPTS_DW1000();                                            \
 }
-#if defined(AMIROLLD_CFG_DW1000)
+#if (BOARD_DW1000_CONNECTED == true)
   #define MODULE_INIT_INTERRUPTS_DW1000() {                                   \
     palSetLineCallback(moduleGpioDw1000Irqn.gpio->line, aosSysGetStdIntCallback(), &moduleGpioDw1000Irqn.gpio->line); \
     palEnableLineEvent(moduleGpioDw1000Irqn.gpio->line, APAL2CH_EDGE(moduleGpioDw1000Irqn.meta.edge));                \
   }
-#else /* defined(AMIROLLD_CFG_DW1000) */
+#else /* (BOARD_DW1000_CONNECTED == true) */
   #define MODULE_INIT_INTERRUPTS_DW1000() {                                   \
   }
-#endif /* defined(AMIROLLD_CFG_DW1000) */
+#endif /* (BOARD_DW1000_CONNECTED == true) */
 
 
 /**
- * @brief   Unit test initialization hook.
+ * @brief   Test initialization hook.
  */
 #define MODULE_INIT_TESTS() {                                                 \
-  /* add unit-test shell commands */                                          \
+  /* initialize tests and add to shell */                                     \
+  aosShellAddCommand(&aos.shell, &moduleTestLedShellCmd);                     \
+  aosShellAddCommand(&aos.shell, &moduleTestButtonShellCmd);                  \
   MODULE_INIT_TESTS_DW1000();                                                 \
+  aosShellAddCommand(&aos.shell, &moduleTestAllShellCmd);                     \
 }
-#if defined(AMIROLLD_CFG_DW1000)
+#if (BOARD_DW1000_CONNECTED == true)
   #define MODULE_INIT_TESTS_DW1000() {                                        \
-    aosShellAddCommand(&aos.shell, &moduleUtAlldDw1000.shellcmd);             \
+    aosShellAddCommand(&aos.shell, &moduleTestDw1000ShellCmd);                \
   }
-#else /* defined(AMIROLLD_CFG_DW1000) */
+#else /* (BOARD_DW1000_CONNECTED == true) */
   #define MODULE_INIT_TESTS_DW1000() {                                        \
   }
-#endif /* defined(AMIROLLD_CFG_DW1000) */
+#endif /* (BOARD_DW1000_CONNECTED == true) */
 
 
 /**
  * @brief   Periphery communication interfaces initialization hook.
  */
-#define MODULE_INIT_PERIPHERY_COMM() {                                        \
+#define MODULE_INIT_PERIPHERY_IF() {                                          \
   /* serial driver */                                                         \
   sdStart(&MODULE_HAL_PROGIF, &moduleHalProgIfConfig);                        \
-  MODULE_INIT_PERIPHERY_COMM_DW1000();                                        \
+  MODULE_INIT_PERIPHERY_IF_DW1000();                                          \
 }
-#if defined(AMIROLLD_CFG_DW1000)
-  #define MODULE_INIT_PERIPHERY_COMM_DW1000() {                               \
+#if (BOARD_DW1000_CONNECTED == true)
+  #define MODULE_INIT_PERIPHERY_IF_DW1000() {                                 \
     /* SPI init */                                                            \
     dw1000_spi_init();                                                        \
     spiStart(&MODULE_HAL_SPI_UWB, &moduleHalSpiUwbLsConfig);                  \
   }
-#else /* defined(AMIROLLD_CFG_DW1000) */
-  #define MODULE_INIT_PERIPHERY_COMM_DW1000() {                               \
+#else /* (BOARD_DW1000_CONNECTED == true) */
+  #define MODULE_INIT_PERIPHERY_IF_DW1000() {                                 \
   }
-#endif /* defined(AMIROLLD_CFG_DW1000) */
+#endif /* (BOARD_DW1000_CONNECTED == true) */
 
 
 /**
  * @brief   Periphery communication interface deinitialization hook.
  */
-#define MODULE_SHUTDOWN_PERIPHERY_COMM() {                                    \
-  MODULE_SHUTDOWN_PERIPHERY_COMM_DW1000();                                    \
+#define MODULE_SHUTDOWN_PERIPHERY_IF() {                                      \
+  MODULE_SHUTDOWN_PERIPHERY_IF_DW1000();                                      \
 }
-#if defined(AMIROLLD_CFG_DW1000)
-#define MODULE_SHUTDOWN_PERIPHERY_COMM_DW1000() {                             \
+#if (BOARD_DW1000_CONNECTED == true)
+#define MODULE_SHUTDOWN_PERIPHERY_IF_DW1000() {                               \
   /* SPI */                                                                   \
   spiStop(&MODULE_HAL_SPI_UWB);                                               \
 }
-#else /* defined(AMIROLLD_CFG_DW1000) */
-  #define MODULE_SHUTDOWN_PERIPHERY_COMM_DW1000() {                           \
+#else /* (BOARD_DW1000_CONNECTED == true) */
+  #define MODULE_SHUTDOWN_PERIPHERY_IF_DW1000() {                             \
   }
-#endif /* defined(AMIROLLD_CFG_DW1000) */
+#endif /* (BOARD_DW1000_CONNECTED == true) */
 
 /**
- * @brief   HOOK to call process_deca_irq() func when the dw1000 interrupt pin is activated.
+ * @brief   HOOK to toggle the LEDs when the user button is pressed.
  */
 #define MODULE_MAIN_LOOP_IO_EVENT(eventflags) {                               \
   if (eventflags & MODULE_OS_IOEVENTFLAGS_USERBUTTON) {                       \
@@ -249,17 +253,20 @@ extern ROMCONST char* moduleShellPrompt;
   }                                                                           \
   MODULE_MAIN_LOOP_IO_EVENT_DW1000();                                         \
 }
-#if defined(AMIROLLD_CFG_DW1000)
+#if (BOARD_DW1000_CONNECTED == true)
+  /**
+   * @brief   HOOK to call process_deca_irq() func when the dw1000 interrupt pin is activated.
+   */
   #define MODULE_MAIN_LOOP_IO_EVENT_DW1000() {                                \
     if(eventflags & MODULE_OS_IOEVENTFLAGS_DW1000_IRQn) {                     \
       /*apalGpioToggle(moduleGpioLedGreen.gpio); // just for debug  */        \
       process_deca_irq();                                                     \
     }                                                                         \
   }
-#else /* defined(AMIROLLD_CFG_DW1000) */
+#else /* (BOARD_DW1000_CONNECTED == true) */
   #define MODULE_MAIN_LOOP_IO_EVENT_DW1000() {                                \
   }
-#endif /* defined(AMIROLLD_CFG_DW1000) */
+#endif /* (BOARD_DW1000_CONNECTED == true) */
 
 /** @} */
 
@@ -278,32 +285,60 @@ extern ROMCONST char* moduleShellPrompt;
  * @{
  */
 /*===========================================================================*/
-#if defined(AMIROLLD_CFG_DW1000)
+#include <alld_LED.h>
+#include <alld_button.h>
+
+/**
+ * @brief   LED driver.
+ */
+extern LEDDriver moduleLldLed;
+
+/**
+ * @brief   Button driver.
+ */
+extern ButtonDriver moduleLldUserButton;
+
+#if (BOARD_DW1000_CONNECTED == true)
+
 #include <alld_DW1000.h>
 
 extern DW1000Driver moduleLldDw1000;
 
-#endif /* defined(AMIROLLD_CFG_DW1000) */
+#endif /* (BOARD_DW1000_CONNECTED == true) */
 
 /** @} */
 
 /*===========================================================================*/
 /**
- * @name Unit tests (UT)
+ * @name Tests
  * @{
  */
 /*===========================================================================*/
 #if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
 
-#if defined(AMIROLLD_CFG_DW1000) && (AMIROLLD_CFG_DW1000 == 1)
-#include <ut_alld_DW1000_v1.h>
+/**
+ * @brief   LED test command.
+ */
+extern aos_shellcommand_t moduleTestLedShellCmd;
+
+/**
+ * @brief   User button test command.
+ */
+extern aos_shellcommand_t moduleTestButtonShellCmd;
+
+#if (BOARD_DW1000_CONNECTED == true)
 
 /**
- * @brief   DW1000 unit test object.
+ * @brief   DW1000 (UWB transmitter) test command.
  */
-extern aos_unittest_t moduleUtAlldDw1000;
+extern aos_shellcommand_t moduleTestDw1000ShellCmd;
 
-#endif /* defined(AMIROLLD_CFG_DW1000) && (AMIROLLD_CFG_DW1000 == 1) */
+#endif /* (BOARD_DW1000_CONNECTED == true) */
+
+/**
+ * @brief   Entire module test command.
+ */
+extern aos_shellcommand_t moduleTestAllShellCmd;
 
 #endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
 
diff --git a/modules/NUCLEO-F103RB/test/LED/module_test_LED.c b/modules/NUCLEO-F103RB/test/LED/module_test_LED.c
new file mode 100644
index 0000000..96c8a1b
--- /dev/null
+++ b/modules/NUCLEO-F103RB/test/LED/module_test_LED.c
@@ -0,0 +1,70 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <module_test_LED.h>
+#include <aos_test_LED.h>
+
+/******************************************************************************/
+/* LOCAL DEFINITIONS                                                          */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED VARIABLES                                                         */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL TYPES                                                                */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL VARIABLES                                                            */
+/******************************************************************************/
+
+static aos_test_leddata_t _data = {
+  /* LED  */ &moduleLldLed,
+};
+
+static AOS_TEST(_test, "LED", NULL, moduleTestLedShellCb, aosTestLedFunc, &_data);
+
+/******************************************************************************/
+/* LOCAL FUNCTIONS                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED FUNCTIONS                                                         */
+/******************************************************************************/
+
+int moduleTestLedShellCb(BaseSequentialStream* stream, int argc, char* argv[], aos_testresult_t* result)
+{
+  (void)argc;
+  (void)argv;
+
+  if (result != NULL) {
+    *result = aosTestRun(stream, &_test, NULL);
+  } else {
+    aosTestRun(stream, &_test, NULL);
+  }
+
+  return AOS_OK;
+}
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
diff --git a/modules/NUCLEO-F103RB/test/LED/module_test_LED.h b/modules/NUCLEO-F103RB/test/LED/module_test_LED.h
new file mode 100644
index 0000000..f9ae6c5
--- /dev/null
+++ b/modules/NUCLEO-F103RB/test/LED/module_test_LED.h
@@ -0,0 +1,66 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+
+#ifndef MODULE_TEST_LED_H
+#define MODULE_TEST_LED_H
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+#if defined(__cplusplus)
+extern "C" {
+#endif /* defined(__cplusplus) */
+  int moduleTestLedShellCb(BaseSequentialStream* stream, int argc, char* argv[], aos_testresult_t* result);
+#if defined(__cplusplus)
+}
+#endif /* defined(__cplusplus) */
+
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
+
+#endif /* MODULE_TEST_LED_H */
+
diff --git a/modules/NUCLEO-F103RB/test/button/module_test_button.c b/modules/NUCLEO-F103RB/test/button/module_test_button.c
new file mode 100644
index 0000000..9990b53
--- /dev/null
+++ b/modules/NUCLEO-F103RB/test/button/module_test_button.c
@@ -0,0 +1,72 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <module_test_button.h>
+#include <aos_test_button.h>
+
+/******************************************************************************/
+/* LOCAL DEFINITIONS                                                          */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED VARIABLES                                                         */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL TYPES                                                                */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL VARIABLES                                                            */
+/******************************************************************************/
+
+static aos_test_buttondata_t _data = {
+  /* button       */ &moduleLldUserButton,
+  /* event source */ &aos.events.io,
+  /* event flags  */ MODULE_OS_IOEVENTFLAGS_USERBUTTON,
+};
+
+static AOS_TEST(_test, "button", NULL, moduleTestButtonShellCb, aosTestButtonFunc, &_data);
+
+/******************************************************************************/
+/* LOCAL FUNCTIONS                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED FUNCTIONS                                                         */
+/******************************************************************************/
+
+int moduleTestButtonShellCb(BaseSequentialStream* stream, int argc, char* argv[], aos_testresult_t* result)
+{
+  (void)argc;
+  (void)argv;
+
+  if (result != NULL) {
+    *result = aosTestRun(stream, &_test, NULL);
+  } else {
+    aosTestRun(stream, &_test, NULL);
+  }
+
+  return AOS_OK;
+}
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
